#ifndef HTML_COLOR_HH
#define HTML_COLOR_HH

#include "html/Attrib.hh"
#include <string>

namespace html {
  class writer;

  class color : public attrib {
  public:
    color(void);
    color(int red, int green, int blue);
    color(const std::string& clr);
    color(const color& x);
    ~color(void);
    attrib* clone(void) const;
    bool isDefault(void) const;
    void putAttr(writer& w) const;
    void setDefault(void);
    void setRGB(int red, int green, int blue);
    void setColorName(const std::string& name);
    bool operator==(const color& x) const;

  private:
    enum ColorMode {
      k_default,
      k_rgb,
      k_named
    };

  private:
    ColorMode mMode;
    int mRed;
    int mGreen;
    int mBlue;
    std::string mName;
  };

}

#endif //  HTML_COLOR_HH
