#ifndef LMSG_BUFFERPOOL_HH
#define LMSG_BUFFERPOOL_HH
#include "lmsg/MsgTypes.hh"
#include "gmutex.hh"
#include <list>

#define DEFAULTBUFFERPOOLSIZE  65536
#define DEFAULTBUFFERPOOLCOUNT    16

namespace lmsg {
  class Buffer;

  class BufferPool {
  public:
    ~BufferPool(void);
    BufferPool(size_type number, size_type length);
    Buffer* getBuffer(void);
    void    returnBuffer(Buffer* buff);
    size_type  getLength(void) const;
    size_type  getDataLength(void) const;
  private:
    typedef std::list<Buffer*> PoolList;
    typedef PoolList::iterator Pool_Iter;
  private:
    size_type   mLength;
    size_type   mCount;
    PoolList mPool;
    thread::mutex mMux;
  }; // Buffer class

} // namespace lmsg

extern lmsg::BufferPool defaultLMsgBufferPool;

#endif // LMSG_BUFFER_HH
