#ifndef _DETECT_H
#define _DETECT_H

#ifdef __cplusplus
extern "C"{
#endif

/*---------------Main declarations for event detector package---------*/

#include <ligostd.h>
#include <signal.h>	
#include <ligoconfig.h>
#include <ligocont.h>

#define absval(inval) (((inval)>=0)? (inval):-(inval))

#ifdef MAINDEF        /* Found in e_detect.c */
   /* Initializations added to comply with objections of Whitesmith linker */

struct r_time etime = {0};	/* Time of beginning of record */
struct r_time htime = {0};	/* Backup of beginning time */

LONG sam_no = 0;      /*the number of the current seismic sample*/
LONG th_wt = 0;	      /*weight, = 1 if >= th2, = 2 if >= th1 -- event*/
LONG fil_out = 0;    /*output of the seismic data filter -- filter*/
LONG lastmin = 0;     /* fix the TIMESTAMP function */

LONG p_rval = 0;      /* fraction of period expressed in millsec--period*/
LONG p_lval = 0;      /* integer value of period--period*/
LONG t_rval = 0;      /* fraction of onset sec  expressed as decimal--time_f*/

struct con_sto *con_ptr;	/* Global continuity structure pointer */
#else

extern	struct r_time etime,htime;
extern	LONG sam_no,th_wt,lastmin,p_rval,p_lval,t_rval;
extern	LONG fil_out;
extern 	struct con_sto *con_ptr;

#endif

#define B_M1	(E_B - 1)	/*buffer index for routine Event*/
#define B_M2	(E_B - 2)
#define B_M3	(E_B - 3)
#define B_M4	(E_B - 4)	/* "	"	"	"	*/	

/*--------------Be friendly to lint-----------------------------*/

  //LONG	Ck_t_kont();
VOID    Cont_setup(struct con_sto*);
VOID 	Count_dn();
BOOL 	E_detect(struct detect_info*, struct s_onset*, int*, const int);
BOOL 	Event();
BOOL    FfirBB256();
VOID 	Ibingo();
VOID 	Period();
LONG	Time_f();
VOID 	Onset(LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,
	      struct detect_info*, struct s_onset*, int*, const int);
VOID 	Onsetq(struct detect_info*, struct s_onset*, int*, const int);
BOOL 	P_one(LONG);
VOID 	P_two();
VOID 	Period();
VOID 	Wbuff();
LONG 	Xth();


#ifdef __cplusplus
}
#endif

#endif   // _DETECT_H 
