#include <TidString.h>
#include <string.h>
#include <malloc.h>

TidString::TidString() {

  size_ = 0;
  cap = stdCap;
  data = (char*)malloc(cap);

}


TidString::TidString(const char *str) { 

  size_ = strlen(str);

  if(size_ < stdCap) cap = stdCap;
  else cap = 2*size_;
    
  data = (char*)malloc(cap);

  memcpy(data,str,size_);

}

TidString::TidString(const char *str, unsigned int size__) { 

  size_ = size__;

  if(size_ < stdCap) cap = stdCap;
  else cap = 2*size_;
    
  data = (char*)malloc(cap);

  memcpy(data,str,size_);

}

TidString::TidString(const string &s) {

  const char *str = s.c_str();

  size_ = strlen(str);

  if(size_ < stdCap) cap = stdCap;
  else cap = 2*size_;
    
  data = (char*)malloc(cap);

  memcpy(data,str,size_);

}

TidString::TidString(const TidString &src) {

  cap=src.cap;
  size_=src.size_;

  data = (char*)malloc(cap);

  memcpy(data,src.data,size_);

}

TidString TidString::operator = (const TidString &src) {

  return TidString(src);

}


void TidString::append(const TidString &src) {

  unsigned int oldsize_ = size_;

  size_ += src.size_;

  if(size_>cap) {
    cap = 2*size_;
    data = (char*)realloc(data,cap);
  }

  memcpy(data+oldsize_, src.data, src.size_);

}


void TidString::append(const string &src) {

  const char* srcdata = src.c_str();
  unsigned int srcsize_ = strlen(srcdata);

  unsigned int oldsize_ = size_;

  size_ += srcsize_;

  if(size_>cap) {
    cap = 2*size_;
    data = (char*)realloc(data,cap);
  }

  memcpy(data+oldsize_, srcdata, srcsize_);

}


void TidString::append(const char *srcdata) {

  unsigned int srcsize_ = strlen(srcdata);

  unsigned int oldsize_ = size_;

  size_ += srcsize_;

  if(size_>cap) {
    cap = 2*size_;
    data = (char*)realloc(data,cap);
  }

  memcpy(data+oldsize_, srcdata, srcsize_);

}


void TidString::append(const char *srcdata, unsigned int srcsize_) {

  unsigned int oldsize_ = size_;

  size_ += srcsize_;

  if(size_>cap) {
    cap = 2*size_;
    data = (char*)realloc(data,cap);
  }

  memcpy(data+oldsize_, srcdata, srcsize_);

}



TidString::~TidString () {

  if(size_) free(data);
  size_ = cap = 0;

}

  
TidString TidString::operator + (const TidString &a) {

  TidString c(*this);

  c+=a;

  return c;

}

TidString TidString::operator + (const string &b) {

  TidString c(*this);

  c+=b;

  return c;

}



TidString TidString::operator + (const char *b) {

  TidString c(*this);

  c+=b;

  return c;

}


const char* TidString::c_str() {

  if(!cap || !size_) return NULL;

  if(size_<cap-1) {data[size_]=0;}
  else {
    cap = 2*size_;
    data = (char*)realloc(data,cap);
    data[size_]=0;
  }

  return data;
}



bool TidString::operator == (const TidString &A) {
  if(A.size_ != size_) return 0;

  for(unsigned int i=0;i<size_;i++)
    if(A.data[i] != data[i]) return 0;

  return 1;
}

bool TidString::operator != (const TidString &A) {

  if(*this==A) return 0;

  return 1;

}


string TidString::Gstring() {

  string out(data,size_);

  return out;
}
