#ifndef TIDSTRINGH
#define TIDSTRINGH

#include <string>
#include <string.h>

using namespace std;

// defines a string class without the limitation on size
// to be used by marshal and TidIO
class TidString {

  static const unsigned int stdCap = 1024; 

  unsigned int cap;

  unsigned int size_;

  char *data;

 public:

  TidString();
  TidString(const char *); // construct from c-string
  TidString(const char *, unsigned int); // construct from c-string
  TidString(const string &);

  TidString(const TidString &); // copy constructor

  bool operator == (const TidString &);
  bool operator != (const TidString &);

  TidString operator = (const TidString &);
  TidString operator + (const TidString &);
  TidString operator + (const string &);
  TidString operator + (const char *);

  void operator += (const TidString &s) {append(s);}
  void operator += (const string &s) {append(s);}
  void operator += (const char* s) {append(s);}

  char operator [] (const unsigned int n) {return data[n];}

  ~TidString();

  unsigned int size() {return size_;}

  void append(const char *);
  void append(const string &);
  void append(const TidString &);
  void append(const char *, unsigned int);

  const char* c_str();

  bool empty() {if(size_) return 0; return 1;}

  string Gstring();
};


#endif
