/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "TrigWriter.hh"
#include "TrigProc.hh"
#include "lmsg/ErrorList.hh"

namespace trig {

  TrigWriter::TrigWriter(void) 
      : mDebug(0)
  {
  }

  TrigWriter::~TrigWriter(void) {
  }

  bool
  TrigWriter::empty(void) const {
      return !getNSegs() && !getNTrigs();
  }

  lmsg::index_type
  TrigWriter::getDebug(void) const {
      return mDebug;
  }

  int 
  TrigWriter::getNSegs(void) const {
      return 0;
  }

  int 
  TrigWriter::getNTrigs(void) const {
      return 0;
  }

  void
  TrigWriter::setDebug(lmsg::index_type d) {
      mDebug = d;
  }

  lmsg::error_type
  TrigWriter::setProcess(const trig::TrigProc& p) {
      mProcess = p;
      return lmsg::OK;
  }


} // namespace trig
