#!/usr/bin/tcsh 

#######################################
#        Initialize the stuff         #
#######################################

if (! $?DMTHOME) setenv DMTHOME /opt/dmt
if (! $?DMTVERSION) setenv DMTVERSION new
setenv LD_LIBRARY_PATH $DMTHOME/$DMTVERSION/lib:/opt/CERN/root/lib:/usr/local/lib:/usr/openwin/lib

set sd=$HOME/dmtspi/cache
set td=$DMTHOME/$DMTVERSION/etc/Spi

mkdir -p $sd
setenv TD "/tmp/"

# Identify machine
setenv gn   `cat /etc/nodename`
setenv g    `cat $td/HOST.lookup | awk '{if($1==gn) print $2}' gn=$gn`
setenv gip  `cat $td/HOST.lookup | awk '{if($1==gn) print $3}' gn=$gn`
setenv gLN  `cat $td/HOST.lookup | awk '{if($1==gn) print $4}' gn=$gn`

# Define remote directories

if ("$gip" == "ligo-wa") then
#  setenv dh "/opt/CDS/a/apacheFiles/htdocs/gds" 
  setenv dh "/src/cds/lho/web/gds/"
  setenv dw "http://blue.ligo-wa.caltech.edu/gds"
endif
if ("$gip" == "ligo-la") then
  setenv dh "/import/space/apacheFiles/htdocs/gds"
  setenv dw "http://london.ligo-la.caltech.edu/gds"
endif

setenv dd "$dh/dmt/Monitors"
setenv d2 "$dw/dmt/Monitors"

mkdir -p $dd/$g

#######################################
#  Look for aged files                #
#######################################

touch $sd/Errors.log
setenv MaxAge 1000

foreach F (`ls $sd | grep spi | grep 'html$'`)
  touch /tmp/timetest 
  setenv NOW `stat -c %Y /tmp/timetest`
  setenv TCH `stat -c %Y $sd/$F`  
  setenv AGE `echo $NOW $TCH | nawk '{a=$1-$2;} END{print a}'`
  setenv STS `echo $AGE $MaxAge | nawk 'BEGIN{b="NEW"} {if($1>$2){b="OLD"}} END{print b}'`

#  echo $F $STS $AGE
  if ($STS == "OLD") then
    cat $td/ErrorCondition.html | nawk '{gsub("REPLACETHIS",A); print $0}' A=$sd/$F > $sd/$F

    echo '<font color="#FF0000">' >> $sd/Errors.log
    echo '<br>'`date`'<br>Obsolete file was found ! Something stopped running!<br>' >> $sd/Errors.log
    echo $sd/$F >> $sd/Errors.log
    echo '<br>After fixing the problem, you must remove the ' $sd/Errors.log 'file!<br>' >> $sd/Errors.log
    echo '</font>' >> $sd/Errors.log

  endif
end

foreach G (`ls $dd/*.html | grep spi`)
  touch /tmp/timetest 
  setenv NOW `stat -c %Y /tmp/timetest`
  setenv TCH `stat -c %Y $G`  
  setenv AGE `echo $NOW $TCH | nawk '{a=$1-$2;} END{print a}'`
  setenv STS `echo $AGE $MaxAge | nawk 'BEGIN{b="NEW"} {if($1>$2){b="OLD"}} END{print b}'`

#  echo $G $STS $AGE
  if ($STS == "OLD") then
    cat $td/ErrorCondition.html | nawk '{gsub("REPLACETHIS",A); print $0}' A=$G > $G

    echo '<font color="#FF0000">' >> $sd/Errors.log
    echo '<br>Obsolete file was found ! Something stopped running!<br>' >> $sd/Errors.log
    echo $G >> $sd/Errors.log
    echo '<br>After fixing the problem, you must remove the ' $sd/Errors.log 'file!<br>' >> $sd/Errors.log
    echo '</font>' >> $sd/Errors.log

  endif
end
